﻿# -*- coding:Utf-8 -*-
#//----------------------------------------------------------//
#//  Script name : Royalglory SX.Mod                         //
#//  Script version : 1.0                                    //
#//  Script Auteur : Sioux (equipe SpiritOfGame-S.O.G)       // 
#//----------------------------------------------------------//
#//  Fichier : rgsxm_weaponremove.py                         //
#//  Auteur : Matth et Sioux (pour Royalglory)               //
#//----------------------------------------------------------//

import es, gamethread, playerlib

weapon_world = []

def es_map_start(event_var):
    global weapon_world
    weapon_world = []

def CreateWeaponIndexList():
    if not len(weapon_world):
        for index in es.createentityindexlist():
            if es.entitygetvalue(index, "classname")[0:6] != "weapon":
                continue
            if es.getindexprop(index, "CBaseEntity.m_hOwnerEntity") == -1:
                weapon_world.append(index)

def DeleteWeaponOnGround(userid):
    for index in es.createentityindexlist():
        if es.entitygetvalue(index, "classname")[0:6] != "weapon":
            continue
        if index not in weapon_world and es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
            es.entitysetvalue(index, 'targetname', index)
            es.fire(userid, index, 'kill')

def round_start(event_var):
    CreateWeaponIndexList()
 
def player_death(event_var):
    callDeletingFunction(event_var['userid'])

def player_disconnect(event_var):
    callDeletingFunction(event_var['userid'])

def item_pickup(event_var):
    if event_var['item'] not in ['vesthelm','vest','nvgs','defuser']:  
        weapon_index = playerlib.getPlayer(event_var['userid']).get('weaponindex', event_var['item'])
        if weapon_index in weapon_world: weapon_world.remove(weapon_index)

def callDeletingFunction(userid):
    gamethread.cancelDelayed("_delete_weapon_thread")
    gamethread.delayedname(.1, "_delete_weapon_thread", DeleteWeaponOnGround, userid)  

def removeIdleWeapons():
        entityList = es.createentitylist()
        for entityIndex in entityList:
                if entityList[entityIndex]['classname'].startswith('weapon_'):
                        if int(es.getindexprop(entityIndex, 'CBaseEntity.m_hOwnerEntity')) == -1:
                                es.server.insertcmd("es_xremove %s" % entityIndex)